const package = require('./package');
const { exec } = require('child_process');
const { writeFileSync } = require('fs');

function main() {
  exec('npm info bee-ui', (error, stdout, stderr) => {
    if (error) return;

    publish(eval("(" + stdout + ")").version);
  });
}

function publish(version) {
  if (version !== package.version) publishRelease();
  publishNightly([package.version, createTimestamp()].join('-'));
}

function publishRelease() {}

function publishNightly(version) {
  package.version = version;
  writeFileSync('./package.json', JSON.stringify(package, null, 2));
  exec('npm publish --tag=nightly');
}

function createTimestamp() {
  // YYYYMMDDHHMM
  const d = new Date();
  return [
    d.getUTCFullYear(), // YYYY
    ('0' + (d.getUTCMonth() + 1)).slice(-2), // MM
    ('0' + (d.getUTCDate())).slice(-2), // DD
    ('0' + (d.getUTCHours())).slice(-2), // HH
    ('0' + (d.getUTCMinutes())).slice(-2) // MM
  ].join('');
}

main();
